%define anolis_release 1

#Global macro/variable 定义
%define _unpackaged_files_terminate_build 0

Name:	     libxudp
Version:     1.0.0
Release:     %{anolis_release}%{?dist}
Summary:     Express UDP(xudp) library
Vendor:      Alibaba
License:     Mulan PSL v2
Url:         https://gitee.com/anolis/libxudp
Source0:     https://gitee.com/anolis/libxudp/releases/download/v%{version}/libxudp-%{version}.tar.gz

BuildRequires: kernel-headers >= 4.19.91
BuildRequires: libnl3-devel
BuildRequires: elfutils-libelf-devel
BuildRequires: libcap-devel
BuildRequires: clang
BuildRequires: llvm

%description
Express UDP is a high-performance UDP communication software library based on the xdp socket technology.

# xudp-tools
%package tools
Summary: Express UDP tools.
Requires: %{name} = %{version}-%{release}
%description tools
Express UDP is a high-performance UDP communication software library based on the xdp socket technology.

# devel
%package devel
Summary: Express UDP devel package.
Requires: %{name} = %{version}-%{release}
%description devel
Express UDP is a high-performance UDP communication software library based on the xdp socket technology.

%prep
%autosetup -n %{name}-%{version} -p1

%build
make prefix=%{buildroot} SO=1

%install
mkdir -p %{buildroot}/usr
mkdir -p %{buildroot}/usr/lib64
mkdir -p %{buildroot}/usr/lib64/pkgconfig
mkdir -p %{buildroot}/usr/include
mkdir -p %{buildroot}/usr/bin
make install prefix=%{buildroot}/usr
cp -p libxudp.pc %{buildroot}/usr/lib64/pkgconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%{_libdir}/libxudp.so.1.0.0
%{_libdir}/libxudp.so.1

%files tools
%{_bindir}/xudp-echo-server
%{_bindir}/xudp-map
%{_bindir}/xudp-dump
%{_bindir}/xudp-stats
%{_bindir}/xudpperf

%files devel
%{_includedir}/xudp.h
%{_libdir}/libxudp.so
%{_libdir}/pkgconfig/libxudp.pc

%changelog
* Mon Aug 15 2022 Xuan Zhuo <xuanzhuo@linux.alibaba.com> - 1.0.0-1
- Initial libxudp

